/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef MICRO_SHARED_H
#define MICRO_SHARED_H

#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>
#include <sched.h>
#include <unistd.h>
#include <iostream>
#include <stdio.h>
#include <pthread.h>
#include "globals.h"
#include "status.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


//#define DEBUG_CFS
//#define SHOW_FILES
//#define NO_THREADS

#define VERBOSE(c) cout << c << endl;
//#define VERBOSE(c)

#define LOG(c) c;
//#define LOG(c) 

// doesn't do anything
#define LOG_FREQUENCY 100


// #define PAUSE
// #define STATS


//#define FILE_SIZE_RANGE CFS_PAGESIZE / 2 - 100
//const int FILE_SIZE_RANGE = 1024*16;
const int FILE_SIZE_RANGE = 16300;
#define MAX_FILENAME 120

struct SampleFile {
  char name [MAX_FILENAME];
  char data;
  int length;
  int groupNumber;
  char dirA;
  char dirB;
  friend ostream& operator << (ostream& os, SampleFile& sampleFile);
  SampleFile (void);
  SampleFile (SampleFile &s);
};

extern SampleFile *file;

extern bool zipfAccess;
extern int zipf;

extern int **createList;
extern int **readList;
extern int **deleteList;
extern int operationCount;

extern int fileCount;
extern int groupCount;
extern int bufferFrameCount;
extern char baseOutputDir [];

extern bool logCreates;
extern bool logReads;
extern bool logDeletes;



void setup (int argc, char **argv);
void startThreads ();
double printTime (FILE* fd, const timeval startTime);

void * createLoop (void * arg);
void * readLoop (void * arg);
void * deleteLoop (void * arg);
void * statsLoop (void * arg);
FILE* openLog (int id, char op);

void flushBufferPool ();
void dumpHitRate ();

/* long timeInRead; */
/* long timeInCreate; */
/* long timeInDelete; */

#endif
