/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef PROXY_H
#define PROXY_H

#include <time.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <pthread.h>
#include <stdlib.h>
#include <iostream.h>
#include <signal.h>
//#include "globals.h"
#include "cfs.h"
#include "proxyThread.h"
//#ifdef USE_CFS
//#else
//#include "ffs.h"
//#endif


//#define GROUP_COUNT 16
//#define BUFFER_NUM 100

// #define PROXY_PORT 8080
//#define MAX_LINE 4096
//#define MAX_LINE 4096
#define MAX_LINE 8192
//#define MAX_BYTES 16384
#define MAX_N 100
//#define MAX_OBJ_SIZE 16300
#define MAX_OBJ_SIZE 64000

class ProxyThread;

class Proxy {
  friend ostream& operator << (ostream& os, Proxy& proxy);
 public:
  Proxy (int port);
  ~Proxy ();
  void run ();

  //  void proxyExit (int signo);

  static Proxy * globalProxy;

/*   static int listenFD; */
/*   static socklen_t addressLength; */
/*   // static pthread_mutex_t mlock; */
/*   static struct sockaddr_in clientAddress; */
/*   static bool shuttingDown; */
/*   static ProxyThread **threads; */
/*   static int threadCount; */
/* #ifdef USE_CFS */
/*   static CFS *fs; */
/* #else */
/*   static FFS *fs; */
/* #endif */

   int listenFD;
   socklen_t addressLength;
   struct sockaddr_in clientAddress;
   bool shuttingDown;
   ProxyThread **threads;
   int threadCount;

   //#ifdef USE_CFS
   CFS *fs;



   //#else
//   FFS *fs;
   //#endif


 private:
  //  void threadMake (ProxyThread *p);
  //void * startThreadLoop (void * arg);
};

#endif
