/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

//#include <list>
#include <set>
#include "status.h"
#include "file.h"

struct Reader {
  friend ostream& operator << (ostream& os, const Reader& reader);
  //  File *file;
  int file;
  int pageNo;

  Reader () {
    cout << "in ()" << endl;
    this->file = 0; this->pageNo = 0;
  }
  Reader (const Reader &r) {
    cout << "in const ctor" << endl;
    this->file = r.file; this->pageNo = r.pageNo;
  }
  Reader (int file, int pageNo) {
    cout << "in assmt ctor" << endl;
    this->file = file; this->pageNo = pageNo;
  }
  Reader& operator= (const Reader& r) {
    cout << "in =" << endl;
    this->file = r.file; this->pageNo = pageNo;
  }
  set (int file, int pageNo) {
    cout << "in set" << endl;
    this->file = file; this->pageNo = pageNo;
  }

  bool operator==(const Reader& r) const {  
    cout << "in equals" << endl;
    if (this->file == r.file && this->pageNo == r.pageNo) {
      cout << "returning true in equals" << endl;
      return true;
    } else {
      cout << "returning false in equals" << endl;
      return false;
    }
  }

  bool operator!=(const Reader& r) const { 
    cout << "in not equals" << endl;
    return (this->file != r.file || this->pageNo != r.pageNo);
  }
  bool operator< (const Reader& r) const {
    cout << "in <" << endl;
    if (this->file < file)
      return true;
    if (this->pageNo < pageNo)
      return true;
    return false;
  }
  bool operator<= (const Reader& r) const {
    cout << "in <=" << endl;
    return (this->file <= file && this->pageNo <= pageNo); }
  bool operator> (const Reader& r) const {
    cout << "in >" << endl;
    return (this->file > file && this->pageNo > pageNo); }
  bool operator>= (const Reader& r) const {
    cout << "in >=" << endl;
    return (this->file >= file && this->pageNo >= pageNo); }
};


struct compare {
    bool operator() (const Reader &r1, const Reader &r2) const {

      return r1 < r2;

/*       cout << "in compare" << endl; */
/*       if (r1 == r2) { */
/* 	cout << "in compare r1 == r2" << endl; */
/* 	return true; */
/*       } else { */
/* 	cout << "in compare r1 != r2" << endl; */
/* 	return false; */
/*       } */
    }
};

// used to restrict readPage and allocPage to only one (file/pageNo) at a time
// this is so that multiple buffers don't get allocated to the same (file/pageNo)
class ReadList {
  friend ostream& operator << (ostream& os, const ReadList& readList);
 private:
  //  set<Reader, compare> reader;
  set<Reader> reader;
  set<Reader>::iterator readerIterator;
 public:
  ReadList ();
  ~ReadList ();
  //  Status add (File *file, int pageNo);
  //  Status remove (File *file, int pageNo);
  Status add (int file, int pageNo);
  Status remove (int file, int pageNo);


};
