/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef REQUEST_QUEUE_H
#define REQUEST_QUEUE_H

#include "page.h"
#include "request.h"

class Disk;
class File;

class RequestQueue {
  friend class Disk;
  friend class File;
  friend ostream& operator << (ostream& os, RequestQueue& queue);
 public:
  RequestQueue (int *head);
  ~RequestQueue ();
  Status enqueue (Request *request);
  Status dequeue (Request *&firstRequest);

  // debugging
  Status verify ();
 
 private:
  pthread_mutex_t mutex;
  pthread_cond_t cv;
  int length;
  // pointer to the disk's head
  int *head;
  Request *first;
  Request *last;
  Request *least;
};

#endif
