/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <iostream>
#include "status.h"
#include "cfs.h"

int main () {

  Status status;

  int groupCount = 16;
  int bufferFrameCount = 32;

  CFS *cfs = new CFS ("/raw/raw/raw4", groupCount, bufferFrameCount, status);

  cfs->love (3);

  char fileName[20];
  sprintf (fileName, "somefile.gif");

  char dataIn[100];
  memset (&dataIn, 'a', 100);
  status = cfs->create (fileName, 3, dataIn, 100);

  int groupNumber;
  status = cfs->lookup (fileName, groupNumber);

  char *dataOut;
  int length;
  status = cfs->read (fileName, groupNumber, dataOut, length);

  status = cfs->release (fileName, groupNumber);

  cfs->hate (groupNumber);
  status = cfs->remove (fileName, groupNumber);


  delete cfs;
  return 0;
}
