/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <iostream>
#include "status.h"

ostream& operator << (ostream& os, Status& status) 
{
  switch (status) {
  case OK:
    os << "OK";
    break;
  case NULL_STATUS:
    os << "Null status";
    break;
  case READ_SOCKET_ERR:
    os << "Read socket error";
    break;
  case WRITE_SOCKET_ERR:
    os << "Write socket error";
    break;
  case NAME_LOOKUP_ERROR:
    os << "Name lookup error";
    break;
  case SERVER_CONNECT_ERROR:
    os << "Server connect error";
    break;
  case SOCKET_ERROR:
    os << "Socket error";
    break;
  case IO_ERROR:
    os << "IO error";
    break;
  case  FILE_NOT_FOUND:
    os << "File not found";
    break;
  case  OUT_OF_MEMORY:
    os << "Out of Memory";
    break;
  case  NOSPACE:
    os << "No space in buffer";
    break;
  case NORECORDS:
    os << "No records in buffer";
    break;
  case INVALIDSLOTNO:
    os << "Invalid slot number in buffer";
    break;
  case BADPAGENO:
    os << "Bad page number in buffer";
    break;
  case BADPAGEPTR:
    os << "Bad page pointer in DB";
  case FILEEXISTS:
    os << "File already exists in DB";
    break;
  case UNIXERR:
    os << "Unix file error in DB";
    break;
  case FILENOTOPEN:
    os << "File not open in DB";
    break;
  case BADFILE:
    os << "Bad filename in DB";
    break;
  case BADFILEPTR:
    os << "Bad file pointer in DB";
    break;
  case FILEOPEN:
    os << "File open";
    break;
  case BUFFEREXCEEDED:
    os << "Buffer pool full";
    break;
  case HASHNOTFOUND:
    os << "Hash entry not found";
    break;
  case BADBUFFER:
    os << "Buffer pool corrupted";
    break;
  case PAGENOTPINNED:
    os << "Page not pinned";
    break;
  case PAGEPINNED:
    os << "Page still pinned";
    break;
  case BUFHASHTBLERROR:
    os << "Buffer hash table error";
    break;
  case PAGES_IN_MEMORY_VECTOR_ERROR:
    os << "Page not found in pagesInMemory vector";
    break;
  case REQUEST_QUEUE_ERROR:
    os << "Request queue error";
    break;
  case DISK_WRITE_ERROR:
    os << "Disk write error";
    break;
  case DISK_READ_ERROR:
    os << "Disk read error";
    break;
  case DISK_ERROR:
    os << "Disk error";
    break;
  case DISK_FULL:
    os << "Disk full";
    break;
  case READ_LIST_ERROR:
    os << "Read list error";
    break;
  case IN_READ_QUEUE:
    os << "Already in read queue";
    break;
  default:
    os << "Unknown status";
    break;
  }
  return os;
}

bool isFatal (const Status &status) {
  if (status == WRITE_SOCKET_ERR || status == READ_SOCKET_ERR || status == SERVER_CONNECT_ERROR) 
    return false;
  return true;
}
