/*
 * Copyright (C) 2001  Jonathan T. Ledlie
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include <stdio.h>
#include <iostream.h>
#include "page.h"


int main()
{
    Page*       page1;

    char	rec1[33];
    char	rec2[58];
    char	rec3[71];
    char        rec4[100];
    char        rec5[789];

    Record record1, record2, record3, record, record4, record5;

    Status	status;
    RID		rid1, rid2, rid3,rid4,rid5, tmpRid1, tmpRid2;
    int 	i,j;	

    record1.data = &rec1;
    record1.length = sizeof(rec1);
    record2.data = &rec2;
    record2.length = sizeof(rec2);
    record3.data = &rec3;
    record3.length = sizeof(rec3);
    record4.data = &rec4;
    record4.length = sizeof(rec4);
    record5.data = &rec5;
    record5.length = sizeof(rec5);


    for (i=0;i<33;i++) rec1[i]='a';
    for (i=0;i<58;i++) rec2[i]='b';
    for (i=0;i<71;i++) rec3[i]='c';
    for (i=0;i<100;i++) rec4[i]='d';
    for (i=0;i<789;i++) rec5[i]='e';

    // create data page
    page1 = new Page();
    page1->init(1);
    page1->dumpPage();

    status = page1->insertRecord(record1, rid1);
    printf("status=%d, rid returned = %d.%d\n",
	status, rid1.pageNo, rid1.slotNo);

    page1->dumpPage();

    status = page1->insertRecord(record2, rid2);
    printf("status=%d, rid returned = %d.%d\n",
	status, rid2.pageNo, rid2.slotNo);

    status = page1->insertRecord(record3, rid3);
    printf("status=%d, rid returned = %d.%d\n",
	status, rid3.pageNo, rid3.slotNo);

    cout << "ins2 length=" << record2.length  << endl;
    page1->dumpPage();

    // try scanning records on the page
    status = page1->firstRecord(tmpRid1);

    for ( i = 0; i < 3; i++)
    {
	// got a rid
        printf("status=%d, rid returned = %d.%d\n",
	  status, tmpRid1.pageNo, tmpRid1.slotNo);
	status = page1->getRecord(tmpRid1, record);

	for (j=0;j<record.length;j++) 
	  printf("%c", ((char *)record.data)[j]); printf("\n");

	// get rid of next record
        status = page1->nextRecord(tmpRid1, tmpRid2);
	if ( i == 2)
	  {
	    if ( status != ENDOFPAGE )
	      cout << "Error returned from nextrecord - expecting ENDOFPAGE" << status << endl;
	    else break;
	  }
	if ( status != OK)
	  cout << "Error returned from nextrecord " << status << endl;
	tmpRid1 = tmpRid2;
    }

    // delete all the records.  First the middle one
    printf("delete rid2=%d.%d\n", rid2.pageNo, rid2.slotNo);
    status = page1->deleteRecord(rid2);
    if (status !=OK) printf("error return from deleteRecord = %d\n",status);
    page1->dumpPage();

    // inserting record 
    status = page1->insertRecord(record4, rid4);
    printf("status=%d, rid returned = %d.%d\n",
	status, rid4.pageNo, rid4.slotNo);
    page1->dumpPage();

    // inserting very large record
    status = page1->insertRecord(record5, rid5);
    printf("status=%d, rid returned = %d.%d\n",
	status, rid5.pageNo, rid5.slotNo);
    if ( status != NOSPACE) 
      cout << " Error : accepted insert of very large record " << endl;
    else cout << "correctly identified that there isn't enough space" << endl;
    page1->dumpPage();

    record5.length-=2;
    status = page1->insertRecord(record5, rid5);
    printf("status=%d, rid returned = %d.%d\n",
	status, rid5.pageNo, rid5.slotNo);
    if ( status != OK)
      cout << " Insertion fails when page is almost full " << endl;
    page1->dumpPage();

    // delete all the records.  next the end one
    printf("delete rid3=%d.%d\n", rid3.pageNo, rid3.slotNo);
    status = page1->deleteRecord(rid3);
    if (status !=OK) printf("error return from deleteRecord = %d\n",status);
    page1->dumpPage();

    // delete rec4
    printf("delete rid4=%d.%d\n", rid4.pageNo, rid4.slotNo);
    status = page1->deleteRecord(rid4);
    if (status !=OK) printf("error return from deleteRecord = %d\n",status);
    page1->dumpPage();

    printf("delete rid5=%d.%d\n", rid5.pageNo, rid5.slotNo);
    status = page1->deleteRecord(rid5);
    if (status != OK) printf("error return from deleteRecord = %d\n",status);
    page1->dumpPage();


    // then the first one
    printf("delete rid1=%d.%d\n", rid1.pageNo, rid1.slotNo);
    status = page1->deleteRecord(rid1);
    if (status !=NORECORDS) printf("error return from deleteRecord = %d\n",status);
    page1->dumpPage();

    
    status = page1->deleteRecord(rid1);
    if (status != INVALIDSLOTNO) printf("error invalidslotno not returned from deleteRecord, instead returns = %d\n",status);
    status = page1->firstRecord(rid1);
    if (status != NORECORDS) printf("error NORECORDS not returned from firstRecord, instead returns = %d\n",status); 
    status = page1->getRecord(rid1,record1);
    if (status != INVALIDSLOTNO) printf("error invalidslotno not returned from getRecord, instead returns = %d\n",status); 
    delete page1;

    printf ("End of tests");

    return (1);
}
